--[[
    Description: Titan plug-in to display Ancient Mana
    Author: InternetH3ro
--]]

local ProfName = "Ancient Mana"
local menutext = "Titan|cF58CBA00 "..ProfName.."|r"
local buttonlabel = ProfName..": "
local ID = "AncMana"
local elap, AM, prevAM = 0, 0.0, -2




-- Main button frame and addon base
local f = CreateFrame("Button", "TitanPanelAncManaButton", CreateFrame("Frame", nil, UIParent), "TitanPanelComboTemplate")
f:SetFrameStrata("FULLSCREEN")
f:SetScript("OnEvent", function(this, event, ...) this[event](this, ...) end)
f:RegisterEvent("ADDON_LOADED")

f:SetScript("OnClick", function(self, button, down)
--local prof = ProfName
--if prof == "Mining" then prof = "Smelting" end
--if prof == "FirstAid" then prof = "First Aid" end
--CastSpellByName(prof)
end)

function f:ADDON_LOADED(a1)

print ("a1 = " .. a1)
    if a1 ~= "TitanAncientMana" then
        return
    end

    self:UnregisterEvent("ADDON_LOADED")
    self.ADDON_LOADED = nil
    
    self.registry = {
        id = ID,
        menuText = menutext,
        buttonTextFunction = "TitanPanelAncManaButton_GetButtonText",
        tooltipTitle = ID,
        tooltipTextFunction = "TitanPanelAncManaButton_GetTooltipText",
        frequency = 1,
        icon = "Interface\\Icons\\inv_misc_ancient_mana.blp",
        iconWidth = 16,
        category = "Information",
        savedVariables = {
            ShowIcon = 1,
            ShowLabelText = false,
            
        },
    }
    self:SetScript("OnUpdate", function(this, a1)
        elap = elap + a1
        if elap < 1 then return end

        local name, currentAmount, texture, isDiscovered = GetCurrencyInfo(1155);

        AM = currentAmount

        if AM == prevAM then
            return
        end

        prevAM = AM
        TitanPanelButton_UpdateButton(ID)
        elap = 0
    end)

end

-------------------------------------------
function TitanPanelAncManaButton_GetButtonText()
-------------------------------------------
    local AMText, pitchtext
    if not AM then
        AMText = "??"
    else
        AMText = AM
    end
    return buttonlabel, AMText
end

--------------------------------------------
function TitanPanelAncManaButton_GetTooltipText()
--------------------------------------------
    return "Displays your current amount of Ancient Mana"
end

local temp = {}
local function UIDDM_Add(text, func, checked, keepShown)
    temp.text, temp.func, temp.checked, temp.keepShownOnClick = text, func, checked, keepShown
    UIDropDownMenu_AddButton(temp)
end

-------------------------------------------------
function TitanPanelRightClickMenu_PrepareAncManaMenu()
-------------------------------------------------
    TitanPanelRightClickMenu_AddTitle(TitanPlugins[ID].menutext)
    TitanPanelRightClickMenu_AddToggleIcon(ID)
    TitanPanelRightClickMenu_AddToggleLabelText(ID)
    TitanPanelRightClickMenu_AddSpacer()
    TitanPanelRightClickMenu_AddCommand(TITAN_PANEL_MENU_HIDE, ID, TITAN_PANEL_MENU_FUNC_HIDE)
end